program pankakeland_rushed_part1;

{Experimenting with 360x480 mode...will it work? :) }

uses crt, kvidpak, videopak, tfmouse, pasdvt;

type
    layer4_ray = array[0..43199] of byte;
    layer4_ptr = ^layer4_ray;
    layer5_ray = array[0..43199] of byte;
    layer5_ptr = ^layer5_ray;

var
   globalfrogger : boolean;
   countw5, countw6 : word;
   cosray : array[0..255] of byte;
   cosrayseg : word;
   cosrayofs : word;
   tweakset : array[0..2047] of byte;
   tweakseg : word;
   tweakofs : word;
   f : file;

   layer4 : layer4_ptr;
   layer5 : layer5_ptr;
   layer4seg, layer5seg, curlayerseg : word;
   palette, palette2 : array[0..767] of byte; {palette2 is a backup}
   j, k : word;

procedure horizline(y : word; color : byte);
begin
     asm
        mov ax, 0a000h
        mov es, ax
        mov dx, 3c4h
        mov ax, 0f02h
        out dx, ax
        mov ax, y
        mov bx, 90
        mul bx
        mov di, ax
        mov cx, 45
        mov al, color
        mov ah, color
        rep stosw
     end;
end;

procedure initcosray;
var
   countw : word;
   temp : real;
begin
     for countw := 0 to 255 do begin
         temp := cos(countw*Pi/128);
         temp := (temp*128)+127;
         cosray[countw] := trunc(temp);
     end;
end;

{------------------------------}

procedure loadpcx360 (filename : string);

{Loads 43200 bytes into each of two halfs of a 360x240x256 PCX, which
 is 86400 bytes total in unpacked size.  These two halves get blitted onto
 one 360x480 screen, interlaced.}

type
    buffer_ray = array[0..63999] of byte;
    buffer_ptr = ^buffer_ray;
var
   f : file;
   count : word;
   pointcount : word;
   buffer : buffer_ptr;
   repnum : byte;
   repval : byte;
   location : word;
   pcxheader : record
               manufacturer : byte;
               version : byte;
               encoding : byte;
               bitsperpixel : byte;
               ulx : word;
               uly : word;
               width : word;
               height : word;
               horizres : word;
               vertres : word;
               egapal : array[0..47] of byte;
               reserved : byte;
               numplanes : byte;
               bytesperline : word;
               palettetype : word;
               padding : array[0..57] of byte;
               end;

begin
     getmem(buffer, 64000);
     assign(f, filename);
     reset(f, 1);
     blockread(f, pcxheader, sizeof(pcxheader));
     blockread(f, buffer^, filesize(f)-128-768);
     pointcount := 0;
     location := 0;

     repeat
           if buffer^[location] < 192 then begin
               layer4^[pointcount] := buffer^[location];
               inc(pointcount);
           end;
           if buffer^[location] >= 192 then begin
               repnum := buffer^[location] - 192;
               inc(location);
               repval := buffer^[location];
               if repnum <> 0 then begin
                  for count := 1 to repnum do begin
                      layer4^[pointcount] := repval;
                      inc(pointcount);
                  end;
               end;
           end;

           inc(location);

     until pointcount = 43200;

     pointcount := 0;

     repeat
           if buffer^[location] < 192 then begin
               layer5^[pointcount] := buffer^[location];
               inc(pointcount);
           end;
           if buffer^[location] >= 192 then begin
               repnum := buffer^[location] - 192;
               inc(location);
               repval := buffer^[location];
               if repnum <> 0 then begin
                  for count := 1 to repnum do begin
                      layer5^[pointcount] := repval;
                      inc(pointcount);
                  end;
               end;
           end;

           inc(location);

     until pointcount = 43200;

     blockread(f, palette, sizeof(palette));
     for count := 0 to 767 do
         palette[count] := palette[count] shr 2;
     freemem(buffer, 64000);
end;

procedure renewpalette;
var
   rr, gg, bb : byte;
   dac : byte;
begin
     for dac := 0 to 255 do begin
         rr := palette[dac*3];
         gg := palette[dac*3+1];
         bb := palette[dac*3+2];
         setpal(dac, rr, gg, bb);
     end;
end;

procedure blitpcxlayers;
var maskcount, count1, count2 : word;
begin
     for maskcount := 0 to 3 do begin

         portw[$3c4] := ((1 shl maskcount) shl 8) + 2;

         for count2 := 0 to 119 do begin
             for count1 := 0 to 89 do begin
                 mem[$a000:count2*180+count1] :=
                    layer4^[count2*360+count1*4+maskcount];
                 mem[$a000:count2*180+count1+90] :=
                    layer4^[count2*360+count1*4+maskcount];

                 mem[$a000:count2*180+count1+(90*240)] :=
                    layer5^[count2*360+count1*4+maskcount];
                 mem[$a000:count2*180+count1+(90*240)+90] :=
                    layer5^[count2*360+count1*4+maskcount];
             end;
         end;

     end;

     portw[$3c4] := $0f02;
end;

{------------------------------}




procedure set360x480;
begin
     asm
        mov     ax, 13h
        int     10h

        mov     dx, 3c4h
        mov     ax, 0604h
        out     dx, ax

        mov     dx, 3c4h
        mov     ax, 0f02h
        out     dx, ax

        mov     ax, 0a000h
        mov     es, ax
        xor     di, di
        xor     ax, ax
        mov     cx, 8000h
        cld
        rep     stosw

        mov     dx, 3c4h
        mov     ax, 0604h
        out     dx, ax

        call    waitforverticalretrace

        cli

        mov     dx, 3c4h
        mov     ax, 100h
        out     dx, ax
        mov     dx, 3c2h
        mov     al, 0e7h   {clock setting - might be e3h in some 320 tweaks}
        out     dx, al
        mov     dx, 3c4h
        mov     ax, 300h
        out     dx, ax

        mov     dx, 3d4h
        mov     al, 11h
        mov     ah, 0ACh
        and     ah, 7fh
        out     dx, ax

        {CRTC loop}

        mov     dx, 3d4h

        mov     al, 0
        mov     ah, 6Bh
        out     dx, ax

        mov     al, 1
        mov     ah, 59h
        out     dx, ax

        mov     al, 2
        mov     ah, 5ah
        out     dx, ax

        mov     al, 3
        mov     ah, 8eh
        out     dx, ax

        mov     al, 4
        mov     ah, 5eh
        out     dx, ax

        mov     al, 5
        mov     ah, 8ah
        out     dx, ax

        mov     al, 6
        mov     ah, 0Dh
        out     dx, ax

        mov     al, 7
        mov     ah, 3Eh
        out     dx, ax

        mov     al, 8
        mov     ah, 0
        out     dx, ax

        mov     al, 9
        mov     ah, 40h
        out     dx, ax

        mov     al, 0ah
        mov     ah, 0
        out     dx, ax

        mov     al, 0bh
        mov     ah, 0
        out     dx, ax

        mov     al, 0ch
        mov     ah, 0
        out     dx, ax

        mov     al, 0dh
        mov     ah, 0
        out     dx, ax

        mov     al, 0eh
        mov     ah, 0
        out     dx, ax

        mov     al, 0fh
        mov     ah, 31h
        out     dx, ax

        mov     al, 10h
        mov     ah, 0eah
        out     dx, ax

        mov     al, 11h
        mov     ah, 0ach
        out     dx, ax

        mov     al, 12h
        mov     ah, 0dfh
        out     dx, ax

        mov     al, 13h
        mov     ah, 2dh
        out     dx, ax

        mov     al, 14h
        mov     ah, 0
        out     dx, ax

        mov     al, 15h
        mov     ah, 0e7h
        out     dx, ax

        mov     al, 16h
        mov     ah, 6
        out     dx, ax

        mov     al, 17h
        mov     ah, 0e3h
        out     dx, ax

        sti

end;
end;

procedure plasmatize;
var
   d1, d2, d3, d4 : word;
   d5, d6, d7, d8 : word;
   tempw : word;
   countw : word;
   x1, y1 : word;
   darkosc : byte;
   temposc : byte;
   moron : word;
begin
     moron := 400;

     repeat
{     countw := 140*90;
     d3 := cosray[d1];
     d4 := cosray[d2];
     for y1 := 0 to 199 do begin {variable}
{     for x1 := 0 to 89 do begin {constant}
{         mem[$a000:countw] := (cosray[(x1+d1) and 255]) shr 2 +
                              (cosray[(y1+d2) and 255]) shr 2 +
                              (cosray[(x1+d3) and 255]) shr 2 +
                              (cosray[(y1+d4) and 255]) shr 2;
         inc(countw);
     end;
     end;
         inc(d1, 6); d1 := d1 and 255;
         dec(d2, 2); d2 := d2 and 255;}

     waitforverticalretrace;
     asm
        push    ds
        push    si
        mov     ax, 0a000h
        mov     es, ax
        mov     ax, cosrayseg
        mov     ds, ax
        mov     si, cosrayofs
        mov     di, 104*90 {200 lines = 40*90}

{        mov     ax, d1
        and     ax, 255
        add     si, ax
        mov     bl, byte ptr [ds:si]
        xor     bh, bh
        sub     si, ax
        mov     d3, bx
        mov     ax, d2
        and     ax, 255
        add     si, ax
        mov     bl, byte ptr [ds:si]
        sub     si, ax
        xor     bh, bh
        mov     d4, bx}

        mov     dx, 136
      @outerloop:
        add     di, 90
        mov     cx, 90
      @innerloop:
        xor     bx, bx
        mov     ax, 90
        sub     ax, cx
        add     ax, d1
        and     ax, 255
        add     si, ax
        mov     tempw, ax
        mov     al, byte ptr [ds:si]
        xor     ah, ah
        add     bx, ax
        sub     si, tempw

        mov     ax, 200
        sub     ax, dx
        add     ax, d2
        and     ax, 255
        add     si, ax
        mov     tempw, ax
        mov     al, byte ptr [ds:si]
        xor     ah, ah
        add     bx, ax
        sub     si, tempw

        mov     ax, 90
        sub     ax, cx
        add     ax, d3
        and     ax, 255
        add     si, ax
        mov     tempw, ax
        mov     al, byte ptr [ds:si]
        xor     ah, ah
        add     bx, ax
        sub     si, tempw

        mov     ax, 200
        sub     ax, dx
        add     ax, d4
        and     ax, 255
        add     si, ax
        mov     tempw, ax
        mov     al, byte ptr [ds:si]
        xor     ah, ah
        add     bx, ax
        sub     si, tempw

        shr     bx, 3
        add     bx, 128
        mov     byte ptr [es:di], bl
        inc     di
        dec     cx
        jnz     @innerloop

        dec     dx
        jnz     @outerloop

        sub     d1, 3
        add     d2, 2
        add     d3, 4
        sub     d4, 1

        pop     si
        pop     ds
     end;

{     asm
        push    ds
        push    si
        mov     ax, 0a000h
        mov     es, ax
        mov     ax, cosrayseg
        mov     ds, ax
        mov     si, cosrayofs
        mov     di, 105*90 {200 lines = 40*90}
{
        mov     ax, d5
        and     ax, 255
        add     si, ax
        mov     bl, byte ptr [ds:si]
        xor     bh, bh
        sub     si, ax
        mov     d7, bx
        mov     ax, d6
        and     ax, 255
        add     si, ax
        mov     bl, byte ptr [ds:si]
        sub     si, ax
        xor     bh, bh
        mov     d8, bx

        mov     dx, 136
      @outerloop:
        add     di, 90
        mov     cx, 90
      @innerloop:
        xor     bx, bx
        mov     ax, 90
        sub     ax, cx
        add     ax, d5
        and     ax, 255
        add     si, ax
        mov     tempw, ax
        mov     al, byte ptr [ds:si]
        xor     ah, ah
        add     bx, ax
        sub     si, tempw

        mov     ax, 200
        sub     ax, dx
        add     ax, d6
        and     ax, 255
        add     si, ax
        mov     tempw, ax
        mov     al, byte ptr [ds:si]
        xor     ah, ah
        add     bx, ax
        sub     si, tempw

        mov     ax, 90
        sub     ax, cx
{        add     ax, d3}
{        and     ax, 255
        add     si, ax
        mov     tempw, ax
        mov     al, byte ptr [ds:si]
        xor     ah, ah
        add     bx, ax
        sub     si, tempw

        mov     ax, 200
        sub     ax, dx
{        add     ax, d4}
{        and     ax, 255
        add     si, ax
        mov     tempw, ax
        mov     al, byte ptr [ds:si]
        xor     ah, ah
        add     bx, ax
        sub     si, tempw

        shr     bx, 2
        mov     byte ptr [es:di], bl
        inc     di
        dec     cx
        jnz     @innerloop

        dec     dx
        jnz     @outerloop

        sub     d5, 2
        and     ax, 255
        add     d6, 4
        and     ax, 255

        pop     si
        pop     ds
     end;}

     dec(moron);
     until moron = 0;
end;

procedure tweakychr6(twchar : char; x, y : word; color : byte);
{goes in 6-column wide blocks, for 60 columns total text.
 X mod 4 = 0, no shifting.
 X mod 4 = 1, shift left by 2 pixels (do first 2 columns on previous byte).
 Every two characters means 3 bytes in memory.

 ....;;;;....;;;;....;;;;....;;;;....;;;;
 AAAAAABBBBBB
}
var
   ccount : byte;
   tempb, cchar : byte;
   cloc : word;
   pixloc : word;
   shifted : boolean;
begin
     cloc := ord(twchar)*8;
     pixloc := y*90+((x shr 1)*3);
     if (x and 1) = 1 then shifted := true else shifted := false;

     if not shifted then begin

     for ccount := 0 to 7 do begin
         cchar := tweakset[cloc+ccount];
         portw[$3c4] := $0102;
         if (cchar and 128) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc] := color;end;
         portw[$3c4] := $0202;
         if (cchar and 64) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc] := color;end;
         portw[$3c4] := $0402;
         if (cchar and 32) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc] := color;end;
         portw[$3c4] := $0802;
         if (cchar and 16) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc] := color;end;

         portw[$3c4] := $0102;
         if (cchar and 8) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc+1] := color;end;
         portw[$3c4] := $0202;
         if (cchar and 4) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc+1] := color;end;

         pixloc := pixloc+180;
         portw[$3c4] := $0F02;
     end; {ccount}

     end else begin {shifted}

     for ccount := 0 to 7 do begin
         cchar := tweakset[cloc+ccount];
         portw[$3c4] := $0402;
         if (cchar and 128) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc+1] := color;end;
         portw[$3c4] := $0802;
         if (cchar and 64) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc+1] := color;end;

         portw[$3c4] := $0102;
         if (cchar and 32) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc+2] := color;end;
         portw[$3c4] := $0202;
         if (cchar and 16) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc+2] := color;end;
         portw[$3c4] := $0402;
         if (cchar and 8) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc+2] := color;end;
         portw[$3c4] := $0802;
         if (cchar and 4) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc+2] := color;end;

         pixloc := pixloc+180;
         portw[$3c4] := $0F02;

     end; {ccount}

     end; {shifted}
end;

procedure tweakychr(twchar : char; x, y : word; color : byte);
var
   ccount : byte;
   tempb, cchar : byte;
   cloc : word;
   pixloc : word;
begin
     cloc := ord(twchar)*8;
     pixloc := y*90+x;
     for ccount := 0 to 7 do begin
         cchar := tweakset[cloc+ccount];
         portw[$3c4] := $0102;
         if (cchar and 128) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc] := color;end;
         portw[$3c4] := $0202;
         if (cchar and 64) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc] := color;end;
         portw[$3c4] := $0402;
         if (cchar and 32) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc] := color;end;
         portw[$3c4] := $0802;
         if (cchar and 16) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc] := color;end;

         portw[$3c4] := $0102;
         if (cchar and 8) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc+1] := color;end;
         portw[$3c4] := $0202;
         if (cchar and 4) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc+1] := color;end;
         portw[$3c4] := $0402;
         if (cchar and 2) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc+1] := color;end;
         portw[$3c4] := $0802;
         if (cchar and 1) <> 0 then begin
            tempb := mem[$a000:pixloc]; mem[$a000:pixloc+1] := color;end;

         pixloc := pixloc+90;
         portw[$3c4] := $0F02;
     end;

end;

procedure tweakystr(s : string; x, y : word; color : byte);
var scount : byte;
begin
     scount := 1;
     while ord(s[scount]) <> 0 do begin
           tweakychr(s[scount], x+(scount shl 1)-2, y, color);
{            tweakychr(s[scount], x+scount-1, y, color);}
           inc(scount);
     end;
end;

procedure tweakystr6(s : string; x, y : word; color : byte);
var scount : byte;
vcount : byte;
begin
     vcount := ord(s[0]);
     for scount := 1 to vcount do begin;
{           tweakychr6(s[scount], x+(scount shl 1)-2, y, color);}
            tweakychr6(s[scount], x+scount-1, y, color);
     end;
end;

procedure centertweakystr(s : string; y : word);
var starter : word;
begin
     starter := 30-(length(s) div 2);
     tweakystr6(s, starter, y, 15);
end;

procedure setwritemode1;
begin
     asm
        mov dx, 3ceh
        mov al, 5
        out dx, al
        inc dx
        in  al, dx
        and al, 0FCh
        or  al, 1
        out dx, al
     end;
end;

procedure copyline1(srcy, desty : word);
begin
     asm
        push ds
        push si
        mov ax, 0a000h
        mov es, ax
        mov ds, ax
        mov ax, srcy
        mov bx, 90
        mul bx
        mov si, ax
        mov ax, desty
        mov bx, 90
        mul bx
        mov di, ax
        mov cx, 45
        rep movsw
        pop si
        pop ds
     end;
end;

procedure movelines;
var
   bound1, bound2 : word;
begin
     bound1 := 0;
     bound2 := 479;
     repeat
           waitforverticalretrace;
           copyline1(bound1+4, bound1+5);
           copyline1(bound1+3, bound1+4);
           copyline1(bound1+2, bound1+3);
           copyline1(bound1+1, bound1+2);
           copyline1(bound1, bound1+1);
           copyline1(bound1+6, bound1);
           inc(bound1);

           copyline1(bound2-4, bound2-5);
           copyline1(bound2-3, bound2-4);
           copyline1(bound2-2, bound2-3);
           copyline1(bound2-1, bound2-2);
           copyline1(bound2, bound2-1);
           copyline1(bound2-6, bound2);
           dec(bound2);
     until bound1 = 100;
end;

procedure mousedot(x, y : word; color : byte);
begin
     setmouseposition(x shl 1, y);
     waitforverticalretrace;
     hidemouse;
     putpixel(x, y, color);
     showmouse;
end;

procedure mousehoriz(x1, x2, y : word; color : byte);
var tempest : word;
begin
     for tempest := x1 to x2 do
         mousedot(tempest, y, color);
end;

procedure mousevert(x, y1, y2 : word; color : byte);
var tempest : word;
begin
     for tempest := y1 to y2 do
         mousedot(x, tempest, color);
end;

procedure mousehorizback(x1, x2, y : word; color : byte);
var tempest : word;
begin
     for tempest := x1 downto x2 do
         mousedot(tempest, y, color);
end;

procedure mousevertback(x, y1, y2 : word; color : byte);
var tempest : word;
begin
     for tempest := y1 downto y2 do
         mousedot(x, tempest, color);
end;

procedure init69;
begin
     asm
        mov bx, 0069h
        mov al, 0
        call VT_SetSem
     end;
end;

procedure check69;
begin
     asm
        @thingwait:
        mov bx, 0069h
        mov al, 1
        call VT_GetSem
        jne @thingwait
     end;
end;

begin
     if not MousePresent then begin
        writeln;
        writeln('You need a mouse for this quicktro.');
        writeln('It''s stupid, yes, we know...');
        halt(1);
     end;

     init69;
     initcosray;
     cosrayseg := seg(cosray);
     cosrayofs := ofs(cosray);
     getmem(layer4, 43200);
     getmem(layer5, 43200);

     loadpcx360('rushed02.dat');

     set360x480; {this mode RULES!!! :)}

{     assign(f, 'c:\tp\bin\tweaky2.twf');
     reset(f, 1);
     blockread(f, tweakset, filesize(f));
     close(f);
     tweakseg := seg(tweakset);
     tweakofs := ofs(tweakset);
}

{     tweakychr6('K',34,102,127);
     tweakychr6('I',35,102,127);
     tweakychr6('W',36,102,127);
     tweakychr6('I',37,102,127);
     tweakychr6('D',38,102,127);
     tweakychr6('O',39,102,127);
     tweakychr6('G',40,102,127);}

{     centertweakystr('RESOLUTION 1995',120);
     centertweakystr('THIS SUCKS',120+16);
     centertweakystr('THIS SUCKS',120+32);
     centertweakystr('THIS SUCKS',120+48);
     centertweakystr('THIS SUCKS',120+64);
     centertweakystr('THIS SUCKS',120+80);
     centertweakystr('THIS SUCKS',120+96);
     centertweakystr('THIS SUCKS',120+112);
     centertweakystr('THIS SUCKS',120+128);
     centertweakystr('THIS SUCKS',120+144);
     centertweakystr('THIS SUCKS',120+160);
     centertweakystr('THIS SUCKS',120+176);
     centertweakystr('THIS SUCKS',120+192);
     centertweakystr('THIS SUCKS',120+208);
     centertweakystr('CHANGE IT',120+224);}
{
     This has been very rushed production by Kiwidog, Kneebiter, Fred,
     and Blanka.  Greets go Darkwolf, Miss Saigon, Lethal, Tronster, Frostbyte,
     Moby Disk, Thoughtcrime, Weiland the Happy Pig, the makers of Mountain
     Dew, the people at Pizza Quick, and Floss, but definitely NOT those
     dudes in Chicago. ;)  If you thought this demo was cheezy, then let's
     see YOU do better in three hours.  Remember kids,beer and video
     cards don't mix, and NEVER drink and track!  Peace! (this lame text has
     been Miss Saigon's contribution to this demo)  If you're a lamer and you
     know it, press esc!
}

     {set palette}
{     for countw5 := 0 to 15 do
         setpal(countw5, countw5 shl 2, countw5 shl 2, countw5 shl 2);}
 {    for countw5 := 15 to 31 do
         setpal(countw5, countw5 shl 1, countw5 shl 1, countw5 shl 1);}
 {    for countw5 := 32 to 63 do
         setpal(countw5, 64-countw5, 64-countw5, 64-countw5);
     for countw5 := 64 to 127 do
         setpal(countw5, 0, 0, (countw5-64) shr 1);}

     for countw5 := 0 to 255 do
         setpal(countw5, 0, 0, 0);

     blitpcxlayers;
     loadpcx360('rushed01.dat');

     for countw5 := 128 to 191 do
         setpal(countw5, 0, 0, 32-((countw5-128) shr 1));
     for countw5 := 192 to 255 do
         setpal(countw5, 0, 0, ((countw5-192) shr 2));

     horizline(0, 6);
     horizline(1, 8);
     horizline(2, 10);
     horizline(3, 12);
     horizline(4, 14);

     horizline(479, 6);
     horizline(478, 8);
     horizline(477, 10);
     horizline(476, 12);
     horizline(475, 14);

     {fadeup}
     countw5 := 0;
     repeat
     for countw6 := 0 to 15 do
         setpal(countw6, countw6 shl countw5,countw6 shl countw5,
                         countw6 shl countw5);
     delay(100);
     inc(countw5);
     until countw5 = 3;

     movelines;
     blitpcxlayers;

     check69;

     {stupid flash}
     waitforverticalretrace;
     for countw5 := 0 to 255 do
         setpal(countw5, 63, 63, 63);

     delay(80);

     waitforverticalretrace;
     for countw5 := 0 to 15 do
         setpal(countw5, countw5 shl 2, countw5 shl 2, countw5 shl 2);
     for countw5 := 16 to 127 do
         setpal(countw5, 0, 0, 0);
     for countw5 := 128 to 191 do
         setpal(countw5, 32-((countw5-128) shr 1), 0, 0);
     for countw5 := 192 to 255 do
         setpal(countw5, ((countw5-192) shr 2), 0, 0);

     blitpcxlayers;
     plasmatize;
     flashdown(1);

     videomode($13);

     setmouseposition(240,60);
     showmouse;
     delay(1000);
     mousehoriz(120, 200, 60, 15);
     mousevert(200,60,140, 15);
     mousehorizback(200, 120, 140, 15);
     mousevertback(120, 140, 60, 15);
     mousevert(120, 60, 80, 15);
     mousehoriz(121, 140, 80, 0);
     mousevert(140, 80, 120, 15);
     mousevertback(140, 120, 100, 15);
     mousehoriz(140, 159, 100, 15);
     mousevert(160, 100, 120, 0);
     mousevertback(160, 120, 80, 15);
     mousehoriz(161, 180, 80, 0);
     mousevert(180, 80, 120, 15);
     mousehoriz(181, 199, 120, 0);
     mousehoriz(200, 200, 120, 15);
     mousehoriz(201, 250, 120, 0);
     delay(4000);

     freemem(layer4, 43200);
     freemem(layer5, 43200);
     videomode(3);
end.